OpenCL C++ Bindings: cl::Event Class Reference

OpenCL C++ Bindings

Loading...
Searching...
No Matches
cl::Event Class Reference

Class interface for cl_event. More...

`#include <opencl.hpp>`

Inheritance diagram for cl::Event:

## Public Member Functions
| Event ()
| Default constructor - initializes to nullptr.
| Event (const cl_event &event, bool retainObject=false)
| Constructor from cl_event - takes ownership.
Event & | operator= (const cl_event &rhs)
| Assignment operator from cl_event - takes ownership.
template<typename T>
cl_int | getInfo (cl_event_info name, T *param) const
| Wrapper for clGetEventInfo().
template<cl_event_info name>
detail::param_traits< detail::cl_event_info, name >::param_type | getInfo (cl_int *err=nullptr) const
| Wrapper for clGetEventInfo() that returns by value.
template<typename T>
cl_int | getProfilingInfo (cl_profiling_info name, T *param) const
| Wrapper for clGetEventProfilingInfo().
template<cl_profiling_info name>
detail::param_traits< detail::cl_profiling_info, name >::param_type | getProfilingInfo (cl_int *err=nullptr) const
| Wrapper for clGetEventProfilingInfo() that returns by value.
cl_int | wait () const
| Blocks the calling thread until this event completes.
cl_int | setCallback (cl_int type, void(CL_CALLBACK *pfn_notify)(cl_event, cl_int, void *), void *user_data=nullptr)
| Registers a user callback function for a specific command execution status.
Public Member Functions inherited from cl::detail::Wrapper< cl_event >
Wrapper< cl_type > & | operator= (const Wrapper< cl_type > &rhs)
const cl_type & | operator() () const
cl_type | get () const

## Static Public Member Functions
static cl_int | waitForEvents (const vector< Event > &events)
| Blocks the calling thread until every event specified is complete.

## Additional Inherited Members
Public Types inherited from cl::detail::Wrapper< cl_event >
typedef cl_event | cl_type
Protected Member Functions inherited from cl::detail::Wrapper< cl_event >
cl_int | retain () const
cl_int | release () const
Protected Attributes inherited from cl::detail::Wrapper< cl_event >
cl_type | object_

## Detailed Description

Class interface for cl_event.

Note
  Copies of these objects are shallow, meaning that the copy will refer to the same underlying cl_event as the original. For details, see clRetainEvent() and clReleaseEvent().

See also
  cl_event

Definition at line 3699 of file opencl.hpp.

## Constructor & Destructor Documentation

## ◆ Event() [1/2]

cl::Event::Event | ( |  | ) |
| inline

Default constructor - initializes to nullptr.

Definition at line 3703 of file opencl.hpp.

## ◆ Event() [2/2]

cl::Event::Event | ( | const cl_event & | event,
|  | bool | retainObject = false )
| inlineexplicit

Constructor from cl_event - takes ownership.

Parameters

  retainObject | will cause the constructor to retain its cl object. Defaults to false to maintain compatibility with earlier versions. This effectively transfers ownership of a refcount on the cl_event into the new Event object.

Definition at line 3713 of file opencl.hpp.

## Member Function Documentation

## ◆ getInfo() [1/2]

template<typename T>

cl_int cl::Event::getInfo | ( | cl_event_info | name,
|  | T * | param ) const
| inline

Wrapper for clGetEventInfo().

Definition at line 3729 of file opencl.hpp.

## ◆ getInfo() [2/2]

template<cl_event_info name>

detail::param_traits< detail::cl_event_info, name >::param_type cl::Event::getInfo | ( | cl_int * | err = nullptr | ) | const
| inline

Wrapper for clGetEventInfo() that returns by value.

Definition at line 3739 of file opencl.hpp.

## ◆ getProfilingInfo() [1/2]

template<cl_profiling_info name>

detail::param_traits< detail::cl_profiling_info, name >::param_type cl::Event::getProfilingInfo | ( | cl_int * | err = nullptr | ) | const
| inline

Wrapper for clGetEventProfilingInfo() that returns by value.

Definition at line 3762 of file opencl.hpp.

## ◆ getProfilingInfo() [2/2]

template<typename T>

cl_int cl::Event::getProfilingInfo | ( | cl_profiling_info | name,
|  | T * | param ) const
| inline

Wrapper for clGetEventProfilingInfo().

Definition at line 3752 of file opencl.hpp.

## ◆ operator=()

Event & cl::Event::operator= | ( | const cl_event & | rhs | ) |
| inline

Assignment operator from cl_event - takes ownership.

This effectively transfers ownership of a refcount on the rhs and calls clReleaseEvent() on the value previously held by this instance.

Definition at line 3721 of file opencl.hpp.

## ◆ setCallback()

cl_int cl::Event::setCallback | ( | cl_int | type,
|  | void(CL_CALLBACK *pfn_notify)(cl_event, cl_int, void *) | ,
|  | void * | user_data = nullptr )
| inline

Registers a user callback function for a specific command execution status.

Wraps clSetEventCallback().

Definition at line 3789 of file opencl.hpp.

## ◆ wait()

cl_int cl::Event::wait | ( |  | ) | const
| inline

Blocks the calling thread until this event completes.

Wraps clWaitForEvents().

Definition at line 3777 of file opencl.hpp.

## ◆ waitForEvents()

cl_int cl::Event::waitForEvents | ( | const vector< Event > & | events | ) |
| inlinestatic

Blocks the calling thread until every event specified is complete.

Wraps clWaitForEvents().

Definition at line 3809 of file opencl.hpp.

The documentation for this class was generated from the following file:

- opencl.hpp